OGRE: Ogre::Volume::HalfFloatGridSource Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Volume::HalfFloatGridSource Class Reference
Optional Components » Volume

A volume source from a 16 Bit float 3D grid capable of loading volume serializations. More...

`#include <OgreVolumeHalfFloatGridSource.h>`

Inheritance diagram for Ogre::Volume::HalfFloatGridSource:
[legend]

## Public Member Functions
| HalfFloatGridSource (const String &serializedVolumeFile, const bool trilinearValue=true, const bool trilinearGradient=false, const bool sobelGradient=false)
| Constructur.
| ~HalfFloatGridSource (void)
| Destructor.
Real | getMaxClampedAbsoluteDensity (void) const
| Gets the maximum absolute density value to be written into the data when combining, influencing the compression rate on serialization.
void | setMaxClampedAbsoluteDensity (Real maxClampedAbsoluteDensity)
| Sets the maximum absolute density value to be written into the data when combining, influencing the compression rate on serialization.
Public Member Functions inherited from Ogre::Volume::GridSource
| GridSource (bool trilinearValue, bool trilinearGradient, bool sobelGradient)
virtual | ~GridSource (void)
| Destructor.
virtual void | combineWithSource (CSGOperationSource *operation, Source *source, const Vector3 &center, Real radius)
| Updates this grid with another source in a certain area.
size_t | getDepth (void) const
| Gets the depth of the texture.
size_t | getHeight (void) const
| Gets the height of the texture.
Real | getValue (const Vector3 &position) const override
| Overridden from VolumeSource.
Vector4 | getValueAndGradient (const Vector3 &position) const override
| Overridden from VolumeSource.
Real | getVolumeSpaceToWorldSpaceFactor (void) const
| Overridden from VolumeSource.
size_t | getWidth (void) const
| Gets the width of the texture.
Public Member Functions inherited from Ogre::Volume::Source
virtual | ~Source (void)
| Destructor.
bool | getFirstRayIntersection (const Ray &ray, Vector3 &result, Real scale=(Real) 1.0, size_t maxIterations=5000, Real maxDistance=(Real) 10000.0) const
| Gets the first intersection of a ray with the volume.
Real | getVolumeSpaceToWorldSpaceFactor (void) const
| Gets a factor to come from volume coordinate to world coordinate.
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, const String &file)
| Serializes a volume source to a discrete grid file with deflated compression.
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, Real maxClampedAbsoluteDensity, const String &file)
| Same as the other serialize function but with a user definable maximum absolute density value.

## Additional Inherited Members
Static Public Attributes inherited from Ogre::Volume::Source
static const size_t | SERIALIZATION_CHUNK_SIZE
| The amount of items being written as one chunk during serialization.
static const uint32 | VOLUME_CHUNK_ID
| The id of volume files.
static const uint16 | VOLUME_CHUNK_VERSION
| The version of volume files.

## Detailed Description

A volume source from a 16 Bit float 3D grid capable of loading volume serializations.

## Constructor & Destructor Documentation

## ◆ HalfFloatGridSource()

Ogre::Volume::HalfFloatGridSource::HalfFloatGridSource | ( | const String & | serializedVolumeFile,
|  | const bool | trilinearValue = true,
|  | const bool | trilinearGradient = false,
|  | const bool | sobelGradient = false )
| explicit

Constructur.

Parameters

  serializedVolumeFile | Which volume serialization to get the data from.
  trilinearValue | Whether to use trilinear filtering (true) or nearest neighbour (false) for the value.
  trilinearGradient | Whether to use trilinear filtering (true) or nearest neighbour (false) for the gradient.
  sobelGradient | Whether to add a bit of blur to the gradient like in a sobel filter.

## ◆ ~HalfFloatGridSource()

Ogre::Volume::HalfFloatGridSource::~HalfFloatGridSource | ( | void |  | ) |

Destructor.

## Member Function Documentation

## ◆ setMaxClampedAbsoluteDensity()

void Ogre::Volume::HalfFloatGridSource::setMaxClampedAbsoluteDensity | ( | Real | maxClampedAbsoluteDensity | ) |

Sets the maximum absolute density value to be written into the data when combining, influencing the compression rate on serialization.

Set it to 0.0 to deactivate.

Parameters

  maxClampedAbsoluteDensity | The maximum absolute density value.

## ◆ getMaxClampedAbsoluteDensity()

Real Ogre::Volume::HalfFloatGridSource::getMaxClampedAbsoluteDensity | ( | void |  | ) | const

Gets the maximum absolute density value to be written into the data when combining, influencing the compression rate on serialization.

Returns
  The maximum absolute density value, 0.0 when deactivated.

The documentation for this class was generated from the following file:

- OgreVolumeHalfFloatGridSource.h